#ifndef S_GTK_UTILS_H
#define S_GTK_UTILS_H

#include <gdk/gdk.h>

#include <gtk/gtk.h>

#include "RGtk.h"

typedef char * string;

USER_OBJECT_ S_checkEnum(USER_OBJECT_ val, const char *const [], const char *const [], 
                          const int cValues[], int len, const char *const enumName);

USER_OBJECT_ S_checkFlag(USER_OBJECT_ val, const char *const [], const char *const [], 
                          const int cValues[], int len, const char *const enumName);


char **asCStringArray(USER_OBJECT_ svec);
USER_OBJECT_ S_newTargetEntry(USER_OBJECT_ target, USER_OBJECT_ flags, USER_OBJECT_ info);

void *getPtrValue(USER_OBJECT_);
USER_OBJECT_ toRPointer(void*, const char *name);


USER_OBJECT_ asRLogical(Rboolean);
USER_OBJECT_ asRInt(int);
USER_OBJECT_ asRNumeric(double);
USER_OBJECT_ asRCharacter(const char *);
USER_OBJECT_ asRGdkAtom(GdkAtom);

USER_OBJECT_ convertGtkArgToSValue(GtkArg arg);
void R_setArgFromSValue(USER_OBJECT_ sval, GtkArg *arg);

USER_OBJECT_ R_createGtkType(GtkType type, const char *name); /* NULL ok for name. */

USER_OBJECT_ R_toRFlag(int value, const char *flagName);

USER_OBJECT_ R_getObjectTypeHierarchy(USER_OBJECT_ sobj);

#if 1
#include "gtkEnum.h"
#include "gdkEnum.h"
#endif

#ifdef USE_GNOME
#include <gnome.h>

#include <libgnomeui/libgnomeui.h>
#include <libgnomeui/gnome-app.h>
#endif


#ifdef USE_GTK_HTML
#include <gtkhtml/gtkhtml.h>
#include <gtkhtml/gtkhtml-embedded.h>
#endif

#ifdef USE_GTK_EXTRA
#include <gtkextra/gtkextra.h>
#endif


#endif
